#include <nRF24L01-STM.h>
#include <RF24-STM.h>
#include <SPI.h>
#include <Servo.h>

Servo servo1;
Servo servo2;
Servo servo3;
Servo servo4;
Servo servo5;
Servo servo6;

RF24 radio(PC14, PC15);

byte data[14];

int inApin[2] = {PB7, PB6}; // INA:   .         
int inBpin[2] = {PB8, PB9}; // INB:   .         
int pwmpin[2] = {PA1, PA2}; // PWM:  

boolean Dir[2];

void setup()
{
  servo1.attach(PA3);
  servo2.attach(PA9);
  servo3.attach(PB0);
  servo4.attach(PA0);
  servo5.attach(PA8);
  servo6.attach(PA10);
  
  pinMode(PB10, INPUT);
  //   .   ,    . 
  for (int i=0; i<2; i++) 
  { 
  pinMode(inApin[i], OUTPUT); 
  pinMode(inBpin[i], OUTPUT); 
  pinMode(pwmpin[i], OUTPUT); 

  digitalWrite(inApin[i], LOW); 
  digitalWrite(inBpin[i], LOW); 
  } 

  radio.begin(); // 
  delay(1000);
  radio.setAutoAck(1);         //  , 1  0 
  radio.setRetries(0, 15);    //(   ,  )     
  radio.setChannel(120);
  radio.openReadingPipe(1, 0xAABBCCDD11LL); 
  radio.setPALevel (RF24_PA_MAX); //  .   RF24_PA_MIN, RF24_PA_LOW, RF24_PA_HIGH, RF24_PA_MAX
  radio.setDataRate (RF24_1MBPS); // .   RF24_2MBPS, RF24_1MBPS, RF24_250KBPS
  radio.powerUp();
  radio.startListening();
  delay(100);
}

void loop() 
{
  if(radio.available())   //  
  {
    radio.read(&data, sizeof(data));
    
    for(byte x=0; x < 2; x++)
    {
      if(data[2*x] > 124+4*x) Dir[x] = 1;
      else Dir[x] = 0;

      motorGo(x, Dir[x], map(data[2*x], 124+4*x, 255*Dir[x], 0, 65535)); 
    }

    servo1.write(map(data[3], 0, 255, 0, 150));
    servo2.write(map(data[4], 0, 255, 0, 180));
    servo3.write(map(data[5], 0, 255, 0, 180));
    servo4.write(map(data[6], 0, 255, 0, 180));
    servo5.write(map(data[7], 0, 255, 0, 180));
    servo6.write(map(data[11], 0, 1, 30, 150));
    
    delay(1); 
  }
}

void motorGo(boolean motor, boolean direct, unsigned int pwm) 
{  
  digitalWrite(inApin[motor], direct); 
  digitalWrite(inBpin[motor], !direct); 
  
  analogWrite(pwmpin[motor], pwm); 
} 